import { Selected } from '~/components/QuickFilter/QuickFilterSelector.vue';
import { Module, Mutation, VuexModule } from 'vuex-module-decorators';
@Module
export default class LocalStorage extends VuexModule {
  id_token = localStorage.getItem('id_token');
  role_State= localStorage.getItem('current_role');
  quickFilterSelectedItem = localStorage.getItem('quickFilter');
  recommendConsultantItem = localStorage.getItem('recommendConsultantItem');

  get idToken(): string|null {
    return this.id_token;
  };

  get currentRole(): string|null {
    return this.role_State;
  };

  get quickFilterSelectedData(): Selected[] {
    return JSON.parse(this.quickFilterSelectedItem || '[]') as Selected[];
  }

  @Mutation storageIdToken(token: string): void {
    localStorage.setItem('id_token', token);
    this.id_token = localStorage.getItem('id_token') ;
  };

  @Mutation storageRole(role:string): void {
    localStorage.setItem('current_role', role);
    this.role_State = localStorage.getItem('current_role');
  };

  @Mutation storageQuickFilter(selected: string): void {
    localStorage.setItem('quickFilter', selected);
    this.quickFilterSelectedItem = localStorage.getItem('quickFilter');
  };

  @Mutation storageRecommendConsultant(selected: string): void {
    localStorage.setItem('recommendConsultantItem', selected);
    this.recommendConsultantItem = localStorage.getItem('recommendConsultantItem');
  }

  @Mutation storageClear(): void {
    localStorage.removeItem('myRequests');
    localStorage.removeItem('userInfo');
    localStorage.removeItem('id_token');
    localStorage.removeItem('current_role');
    this.id_token = localStorage.getItem('id_token');
    this.role_State = localStorage.getItem('current_role');
  }

  @Mutation storageClearQuickFilter() {
    localStorage.removeItem('quickFilter');
    this.quickFilterSelectedItem = localStorage.getItem('quickFilter');
  }

  @Mutation storageClearRecommendConsultant() {
    localStorage.removeItem('recommendConsultantItem');
    this.recommendConsultantItem = localStorage.getItem('recommendConsultantItem');
  }

}
